<template>
  <div class="q-pa-md">
    <q-table
      title="Supplier"
      :rows="suppliers"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
    >
      <template v-slot:body-cell-action="suppliers">
        <q-td :suppliers="suppliers" align="left" width="20px">
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(suppliers.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(suppliers.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:body-cell-store="suppliers">
        <q-td :suppliers="suppliers" align="left">
          {{suppliers.row.store.name}}
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add Supplier"
          @click="ShowAddModal()"   
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          :disable="loading"
          label="Delete category"
          @click="removeRow"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModal = false"
      >
        <q-card-section>
          <div class="text-h6">New suppliers</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="AddData.name" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Phone</div>
          <q-input dense v-model="AddData.phone" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Type</div>
          <q-input dense v-model="AddData.type" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Store</div>
          <q-select
            filled
            v-model="AddData.store_id"
            :options="stores"
            label="Select store"
            emit-value
            map-options
          />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="CloseAddModle" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Dialog -->

    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendEditModal"
        @keyup.esc="EditModal = false"
      >
        <q-card-section>
          <div class="text-h6">Edit suppliers</div>
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input
            dense
            v-model="EditData.name"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false"
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Phone</div>
          <q-input
            dense
            v-model="EditData.phone"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false"
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Type</div>
          <q-input
            dense
            v-model="EditData.type"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false"
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Store</div>
          <q-select
            filled
            v-model="EditData.store_id"
            :options="stores"
            label="Select store"
            emit-value
            map-options
          />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Update" @click="SendEditData" />
          <q-btn flat label="Cancel" @click="EditModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit Dialog -->

    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete suppliers</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{ DeleteData.name }}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'

export default defineComponent({
  name: 'PageIndex',
  data() {
    return {
      password_error: false,
      search_text: '',
      suppliers: [],
      selected: [],
      stores: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Suppliers Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'phone',
          field: 'phone',
          label: 'Phone',
          align: 'left',
          sortable: true,
        },
        {
          name: 'type',
          field: 'type',
          label: 'Type Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'store',
          field: 'store',
          label: 'Store Name',
          align: 'left',
          sortable: true,
        },
        
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      AddData: {
        id: '',
        name: '',
        phone: '',
        type: '',
        store_id: '',
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      DeleteData: null,
    }
  },
  async mounted() {
    this.$q.loading.show()
    this.user()
    this.store()
  },

  methods: {
    async user() {
      await axios
        .get('http://127.0.0.1:8000/api/suppliers/get_suppliers')
        .then((response) => {
          var data = response.data.data

          console.log(response.data)

          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i,
              id: data[i].id,
              name: data[i].name,
              phone: data[i].phone,
              type: data[i].type,
              store: data[i].store,
            }
            this.suppliers.push(json)
            
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else {
            this.$e('Something Errors')
          }
        })
    },
    ShowAddModal() {
      this.AddModal = true
    },
    async SendAddData() {
      console.log(this.AddData)
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:8000/api/suppliers/create_suppliers',
          this.AddData
        )
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 201) {
            this.$s('Succesfully Create supplier Data')
          this.AddData = {
              id: '',
              name: '',
              phone: '',
              type: '',
              store_id: '',
          }
            this.AddModal = false
            this.suppliers = []
            this.user()
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
            if (res.data.errors.email) {
              this.$e(res.data.errors.email[0])
            }
            if (res.data.errors.password) {
              this.$e(res.data.errors.password[0])
            }
            if (res.data.errors.role_id) {
              this.$e(res.data.errors.role_id[0])
            }
          } else {
            this.$e('Something Error')
          }
        })
      
      this.$q.loading.hide()
    },
    async store() {
      await axios
        .get('http://127.0.0.1:8000/api/suppliers/store')
        .then((response) => {
          var data = response.data
          var a = []
          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            this.stores.push(json)
            
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else {
            this.$e('Something Errors')
          }
        })
      this.$q.loading.hide()
    },
    ShowEditModal(data) {
      console.log(data)
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
        phone: data.phone,
        type: data.type,
        store_id: data.store.id,
      }
    },
    async SendEditData() {
      if (this.EditData.name.length < 3) {
        this.$e('The name must be at least 3 characters.')
        return 0
      }
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:8000/api/suppliers/update_suppliers',
          this.EditData,
        )
        .then((res) => {
          
          if (res.status == 200) {
            this.$s('Succesfully Update suppliers Data')
            this.EditModal = false
            this.$q.loading.hide()
            this.suppliers = []
            this.user()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    ShowDeleteModal(supplier) {
      this.DeleteData = {
        id: supplier.id,
        name: supplier.name,
        phone: supplier.phone,
        type: supplier.type,
      }
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:8000/api/suppliers/delete_suppliers',
          this.DeleteData,
        )
        .then((res) => {
          //console.log(res.msg)

          if (res.status == 200) {
            this.$s('Succesfully Delete supplier')
            this.DeleteModal = false
            this.suppliers = []
            this.user()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    CloseAddModle() {
      this.AddModal = false
      this.AddData = {
        id: '',
        name: '',
        stores_id: '',
      }
    },
  },
})
</script>